/*

Chapter - 5
Project-20 LED as a sensor and Indicator
*/
.include "tn15def.inc"
.cseg
.org 0

;LED as light sensor...
;12th sept 2006


main:
		ldi r16, 255
		out DDRB, r16

		ldi r16, 0
		out PORTB, r16

		ldi r19, 1
	
		rcall delay
	
		ldi r19, 1

new_main:
		sbi DDRB, 0
		nop
		nop
		sbi PORTB, 1 ;LED forward bias
		cbi PORTB, 0
		
	
rcall delay

		sbi PORTB, 0
		cbi PORTB, 1 ; reverse bias

;rcall min_delay


		cbi DDRB, 0 ; LED discharge
		cbi PORTB, 0


; set registers for minimum delay
ldi r19, 1

wait_here:
		sbis PinB, 0
			rjmp its_one
			rcall min_delay
		inc r19
		brne dont_inc_r20
		rjmp over_flow
dont_inc_r20: rjmp wait_here


over_flow:
its_one:
		in r16, PORTB
		ldi r17, 0b00001000
		eor r16, r17 ; toggle PB3 to generate frequency prop to light

		out PORTB, r16

		mov r2, r19
		rcall delay
		mov r19, r2
		rjmp new_main


delay:									
			ldi r20, 0
dec_r20:	
dec_r21:	dec r20
			brne dec_r20
			dec r19
			brne dec_r20
			ret


min_delay: in r0, SREG

			ldi r18, 200
not_over:
			dec r18
			brne not_over
			out SREG, r0
			ret
