/*
Chapter - 5
Project 22 Electronic Firefree matchstick
*/


#include<avr/io.h>
#include<avr/interrupt.h>
#define F_CPU 1600000UL
#include<util/delay.h>

#define OFF 0
#define ON 1

volatile unsigned char mode=OFF;
volatile unsigned long lfsr = 1;

volatile unsigned char temp,i=0;


int main(void)
{
	
	//Wait
	PCMSK = 1<<PCINT4;
	GIFR = 1<<PCIF;
	GIMSK = 1<<PCIE;

	sei();
	DDRB = 0;
	
	
	
	while(1)
	{
		
		i=1;//This is made to ensure that interrupts before this are neglected
		if(mode==ON)
		{
			//Gaolis
			lfsr = (lfsr >> 1) ^ (-(lfsr & 1u) & 0xd0000001u); /* taps 32 31 29 1 */
			temp = (unsigned char) lfsr;

			DDRB= ~temp;
			PORTB = temp;

		
			_delay_loop_2(temp<<7);
		}
		
		
	}
}

ISR(PCINT0_vect)
{
	if(i==1)
	{
		mode = ON;
		GIMSK = 0x00;
		PCMSK = 0x00;
	}
}


