#ifndef DETECTOR_H
#define DETECTOR_H

/*************************************************
* SETTING THRESHOLD
*************************************************/

#define upper_threshold_freq	600			//in khz, divide the freq by 10
//i.e It is 6 khz in above case which gives 6000/10 = 600

#define lower_threshold_freq	200			//in khz, divide the freq by 10
//i.e It is 2 khz in above case which gives 2000/10 = 200


/*************************************************
* PUBLIC CONSTANT
*************************************************/

#define SWITCH_DDR					DDRA
#define SWITCH_PORT					PORTA
#define SWITCH_PIN					PINA
#define SWITCH_1					PA2

/*************************************************
* STATE MACHINE CASES
*************************************************/

#define s0 0								
#define s1 1								
#define s2 2								

/*************************************************
* FUNCTION DECLARATION
*************************************************/

void display_changing_freq(void);			//Display current Frequency
void display_base_freq(uint32_t);			//Display base frequency
void display_car(int);						//Display No. of cars
void LCD_partclear(void);

/*************************************************
* GLOBAL VARIABLE DECLARATION
*************************************************/

uint32_t ovf_counter=0,counts,base_freq,changing_freq;  	
float freq;
int i=6,j=1,select_case,car_counter=0;

#endif
